﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using DA = HeuristicLab.Services.ClientManagement.DataAccess;
using DT = HeuristicLab.Services.ClientManagement.DataTransfer;

namespace HeuristicLab.Services.ClientManagement {
  public static class Convert {

    #region Resource
    public static DT.Resource ToDto(DA.Resource source) {
      return new DT.Resource() {
        Id = source.Id,
        Description = source.Description,
        Name = source.Name,
        Type = source.Type
      };
    }

    public static DA.Resource ToEntity(DT.Resource source) {
      return new DA.Resource() {
        Id = source.Id,
        Description = source.Description,
        Name = source.Name,
        Type = source.Type
      };
    }
    #endregion

    #region Group
    public static DT.Group ToDto(DA.Group source) {
      return new DT.Group() {
        Id = source.Id,
        Description = source.Description,
        Name = source.Name,
        Type = source.Type
      };
    }

    public static DA.Group ToEntity(DT.Group source) {
      return new DA.Group() {
        Id = source.Id,
        Description = source.Description,
        Name = source.Name,
        Type = source.Type
      };
    }
    #endregion

    #region Client
    public static DT.Client ToDto(DA.Client source) {
      return new DT.Client() {
        Id = source.Id,
        Description = source.Description,
        Name = source.Name,
        Type = source.Type,
        Country = source.Country,
        HeuristicLabVersion = source.HeuristicLabVersion,
        IPAddress = source.IPAddress,
        MemorySize = source.MemorySize,
        NumberOfCores = source.NumberOfCores,
        OperatingSystem = source.OperatingSystem,
        ProcessorType = source.ProcessorType
      };
    }

    public static DA.Client ToEntity(DT.Client source) {
      return new DA.Client() {
        Id = source.Id,
        Description = source.Description,
        Name = source.Name,
        Type = source.Type,
        Country = source.Country,
        HeuristicLabVersion = source.HeuristicLabVersion,
        IPAddress = source.IPAddress,
        MemorySize = source.MemorySize,
        NumberOfCores = source.NumberOfCores,
        OperatingSystem = source.OperatingSystem,
        ProcessorType = source.ProcessorType
      };
    }
    #endregion

    #region ClientLog
    public static DT.ClientLog ToDto(DA.ClientLog source) {
      return new DT.ClientLog() {
        Timestamp = source.Timestamp,
        ResourceId = source.ResourceId,
        Exception = source.Exception,
        Message = source.Message
      };
    }

    public static DA.ClientLog ToEntity(DT.ClientLog source) {
      return new DA.ClientLog() {
        Timestamp = source.Timestamp,
        ResourceId = source.ResourceId,
        Exception = source.Exception,
        Message = source.Message
      };
    }
    #endregion
  }
}
